using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace UPSLT
{
	/// <summary>
	/// Summary description for WizardForm.
	/// </summary>
	public class WizardForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;		
		
		private WizardPage wpCurrent;
		private int m_nCurrentPI;
		private string m_strHtml;
		
		public WizardPage ActivePage
		{
			get { return wpCurrent; }
		}
		
		public string Html
		{
			get { return m_strHtml; }
		}

		public WizardForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// WizardForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(399, 350);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "WizardForm";
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "HTML Wizard";
			this.Load += new System.EventHandler(this.WizardForm_Load);

		}
		#endregion

		private void WizardForm_Load(object sender, System.EventArgs e)
		{			
			m_nCurrentPI = 0;			
			ActivatePage((WizardPage)this.Controls[m_nCurrentPI]);
		}
		
		public void AddPage(WizardPage wizPage)
		{
			this.Controls.Add(wizPage);
		}
		
		private void ActivatePage(WizardPage wizPage)
		{
			if (wpCurrent != null)
				wpCurrent.Visible = false;
				
			wizPage.Visible = true;
			wpCurrent = wizPage;
		}
		
		public void NextPage()
		{
			m_nCurrentPI++;
			ActivatePage((WizardPage)this.Controls[m_nCurrentPI]);
		}
		
		public void PrevPage()
		{
			m_nCurrentPI--;
			ActivatePage((WizardPage)this.Controls[m_nCurrentPI]);
		}
		
		public void GenerateHtml()
		{
			BeforeDLWizPage p1 = (BeforeDLWizPage)this.Controls[0];
			IssuesWizPage p2 = (IssuesWizPage)this.Controls[1];
			TroubleshootingWizPage p3 = (TroubleshootingWizPage)this.Controls[2];
										
			m_strHtml = "<p><b>" + p1.txtHeading.Text + "</b><br/>\r\n" +	p1.txtDescription.Text + "</p>" +			
			"<p><b>" + p2.txtHeading.Text + "</b><br/>\r\n\r\n" +
			
			"<ul>\r\n";
			foreach (ListViewItem li in p2.lstIssues.Items)
				m_strHtml += "  <li>" + li.Text + "</li>\r\n";
			m_strHtml += "</ul></p>\r\n\r\n";
			
			m_strHtml += "<p><b>" + p3.txtHeading.Text + "</b><br/>\r\n" +
			p3.txtDescription.Text + "</p>\r\n";			
		}
	}
}
