// polynomial.h  header file

#include <math.h>		// needed for the pow() function
#include <string>		// needed to make use of the stl's basic_string data type

using namespace std;	// need to access the basic_string data type (which is typedef'd to 'string')

// each node of the linked list will contain:
// a pointer to the previous node in the list,
// an integer representing the coefficient,
// an integer representing the exponent,
// a pointer to the next node in the list. 
struct node				
{
	node* prev;
	int coeff;
	unsigned exp;
	node* next;
};


// polynomial class declaration
class polynomial
{
public:
	polynomial();					// constructor
	~polynomial();					// destructor

	string GetPolyAsString();		// returns the polynomial in string representation
	int GetEval(int x);				// returns the value of polynomial for any integer, x
	node* GetTail() const;			// retrieves a pointer to the tail of the polynomial list
	node* GetHead() const;			// retrieves a pointer to the head of the polynomial list
	void InsertTerm(int _coeff, unsigned _exp);		// inserts a term into the polynomial
	polynomial operator+ (polynomial& pol);			// allows for addition of two polynomials

private:
	node* m_head;					// pointer to the head of the polynomial list
	node* m_tail;					// pointer to the tail of the polynomial list
};


