// Graph.h: interface for the Graph class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAPH_H__B99B97CC_53F5_4DAD_8440_64151815ECDF__INCLUDED_)
#define AFX_GRAPH_H__B99B97CC_53F5_4DAD_8440_64151815ECDF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <queue>		// use the stl::queue adt so i dont' have to create my own

// enumerate the states to make them easier to work with
enum us_state {
	WASHINGTON = 0,	OREGON, CALIFORNIA, NEVADA, ARIZONA, UTAH, IDAHO,
	MONTANA, WYOMING, COLORADO, NEW_MEXICO, TEXAS, OKLAHOMA, KANSAS,
	NEBRASKA, SOUTH_DAKOTA,	NORTH_DAKOTA, MINNESOTA, IOWA, MISSOURI, ARKANSAS,
	LOUISIANA, MISSISSIPPI, ALABAMA, TENNESEE, KENTUCKY, ILLINOIS, WISCONSIN,
	MICHIGAN, INDIANA, OHIO, WEST_VIRGINIA, VIRGINIA, NORTH_CAROLINA, SOUTH_CAROLINA,
	GEORGIA, FLORIDA, MARYLAND, DELEWARE, NEW_JERSEY, PENNSYLVANIA, NEW_YORK,
	CONNECTICUT, RHODE_ISLAND, MASSACHUSETTS, VERMONT, NEW_HAMPSHIRE, MAINE };

const int NUM_STATES = 48;		// obvious

class Graph  
{
public:

	void ClearVisitedStates();			// resets the visited array to false
	void BFS(int position);				// performs the breadth-1st search
	void DFS(int position);				// performs the depth-1st search
	void BuildGraph();					// build the graph from a file
	void PrintStateName(int state);		// prints the string rep. of the state


	Graph();							// constructor	
	virtual ~Graph();					// descructor

private:
	std::queue<int> m_queue;				// queue for use w/ the BFS
	int m_matrix[NUM_STATES][NUM_STATES];	// adjacency_matrix for states
	bool m_visited[NUM_STATES];				// array of visited states
};

#endif // !defined(AFX_GRAPH_H__B99B97CC_53F5_4DAD_8440_64151815ECDF__INCLUDED_)
