// usmap.cpp source file

/*
Steve Stchur
COSC336 
12/7/00
Assignment 6

--Purpose--
The purpose of this program is to construct a graph adt which represent a
map of the united states.  Using this graph we will using the DFS and BFS
to traverse the graph and print out a list of the order in which
the states were traversed.

--Algorithm / Concept--
I created a Graph class which is contained in the files "Graph.h" and
"Graph.cpp".  The most important functions are outlined below:

BFS(int position)	// performs the BFS starting at state, position
BuildGraph()		// builds the graph based on the file "adjacent_states.txt"
DFS(int position)	// performs the DFS starting at state, position
PrintStateName(int state)	// prints a string representation of the state

--Important Notes--
I used the STD queue data type for the BFS so that I did not have to create my
own queue class.  Also, it is important to note that there is only one
array used to keep track of the visited states, thus the array must be
reset after each traversal or the results of the next traversal won't be correct.
I realize this is somewhat of a hack, but it does the trick so I decided to
let it go.

--Input / Output--
There is really no input on the user's part unless you count the file
read by the BuildGraph function.  This file is a list of all the adjacent
states.  The ith line number represents state i.  i can be used to 
determine the state via the enum type I created called us_state.
Washington = 0, Oregon = 1, California = 2, etc...
Attatched is a map of the united states w/ each's state's number 
labeled on the map.  In addition is a print out of the file
"adjacent_states.txt".

The program simly displays the result of the DFS first.  It pauses
ever 20 states prompting the user for a key to continue.  When 
the DFS has finished, the BFS results are displayed, again pausing
ever 20 states for readability.

*/

#include <iostream.h>		// obviously needed for console i/o
#include "Graph.h"			// needed for the Graph class

int main()
{
	Graph g;				// create a graph object
	g.BuildGraph();			// build the graph
	
	system("cls");			// clear the screen
	cout << "DEPTH-FIRST SEARCH:" << endl;
	g.DFS(WASHINGTON);		// perform the DFS starting at WASHINGTON

	// pause when the DFS is finished
	cout << endl;
	cout << "--------- End of Depth-First Search ---------\n";
	cout << "Press any key (followed by return) for Breadth-First Search: ";
	char dummy;
	cin >> dummy;

	g.ClearVisitedStates();		// clear the visited states so
								// we can call the BFS
	
	system("cls");				// clear the screen
	cout << "BREADTH-FIRST SEARCH:" << endl;
	g.BFS(WASHINGTON);			// perform the BFS starting at WASHINGTON

	cout << endl;
	cout << "--------- End of Breadth-First Search ---------\n";
	cout << endl;


	
	return 0;		// program terminated normally
}